package com.shanghaichengdi.ghjgitem.controller;


import cn.hutool.http.HttpResponse;
import cn.hutool.http.HttpUtil;
import cn.hutool.http.Method;
import com.alibaba.excel.util.StringUtils;
import com.alibaba.fastjson.JSONObject;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;

import java.nio.charset.Charset;
import java.util.HashMap;
import java.util.Map;

@CrossOrigin
@RestController
@RequestMapping("/dredging")
public class DredgingImport {
    @Value("${dredgingTokenUrl}")
    private String dredgingTokenUrl;
    @Value("${dredgingClientId}")
    private String dredgingClientId;
    @Value("${dredgingClientSecret}")
    private String dredgingClientSecret;
    @Value("${dredgingProjectUrl}")
    private String dredgingProjectUrl;
    @Value("${dredgingElectricFenUrl}")
    private String dredgingElectricFenUrl;
    @Value("${dredgingWorkOrderUrl}")
    private String dredgingWorkOrderUrl;
    @Value("${dredgingWorkTraceUrl}")
    private String dredgingWorkTraceUrl;
    @Value("${dredgingCameraListUrl}")
    private String dredgingCameraListUrl;

    private String token;

    @PostMapping("/token/getToken")
    public Boolean getToken() {
        HttpResponse execute = HttpUtil.createRequest(Method.POST, dredgingTokenUrl).setFollowRedirects(true).form("grant_type", "client_credentials").form("client_id", dredgingClientId).
                form("client_secret", dredgingClientSecret).form("scope", "HPJV2").timeout(30000).execute();
        HashMap map = JSONObject.parseObject(execute.body(), HashMap.class);
        String access_token = map.get("access_token").toString();
        token = access_token;
        return StringUtils.isNotBlank(access_token);
    }

    @PostMapping("/projectOverview/GetProjectOverview")
    public String getProjectOverView(@RequestBody Map<String, String> map) {
        String overView = map.get("ProjectId");
        HttpResponse dredgingProject = HttpUtil.createGet(dredgingProjectUrl + "?ProjectId=" + overView).setFollowRedirects(true).header("Authorization", "Bearer " + token).execute();
        //HttpResponse authorization = HttpUtil.createGet(dredgingProjectUrl + "?ProjectId=" + overView).setFollowRedirects(true).header("Authorization", "Bearer " + token).execute();
        HashMap projectInfos = JSONObject.parseObject(dredgingProject.body(), HashMap.class);
        Object data1 = projectInfos.get("Data");
        if (data1 == null) {
            //这里代表主表的信息不存在，没必要继续进行
            return null;
        }
        return JSONObject.toJSONString(data1);
    }

    @PostMapping("/elecfence/GetElectronicFence")
    public String getElectricFen(@RequestBody Map<String, String> map) {
        String overView = map.get("ProjectId");
        HttpResponse dredgingElectricFen = HttpUtil.createGet(dredgingElectricFenUrl + "?ProjectId=" + overView).setFollowRedirects(true).header("Authorization", "Bearer " + token).execute();
        HashMap fenceInfos = JSONObject.parseObject(dredgingElectricFen.body(), HashMap.class);
        Object data1 = fenceInfos.get("Data");
        if (data1 == null) {
            //这里代表主表的信息不存在，没必要继续进行
            return null;
        }
        return JSONObject.toJSONString(data1);
    }


    @PostMapping("/workOrder/GetWorkOrderList")
    public String getWorkOrder(@RequestBody Map<String, String> map) {
        String overView = map.get("ProjectId");
        HttpResponse workOrder = HttpUtil.createGet(dredgingWorkOrderUrl + "?ProjectId=" + overView).
                setFollowRedirects(true).header("Authorization", "Bearer " + token).charset(Charset.defaultCharset()).execute();
        HashMap workOrderInfo = JSONObject.parseObject(workOrder.body(), HashMap.class);
        Object data1 = workOrderInfo.get("Data");
        if (data1 == null) {
            //这里代表主表的信息不存在，没必要继续进行
            return null;
        }
        return JSONObject.toJSONString(data1);
    }

    @PostMapping("/workOrderHistory/getWorkHistory")
    public String getWorkOrderHistory(@RequestBody Map<String, String> map) {
        String transportCode = map.get("TransportCode");
        String workOrderCode = map.get("WorkOrderCode");
        HttpResponse workTrace = HttpUtil.createGet(dredgingWorkTraceUrl + "?TransportCode=" + transportCode + "&WorkOrderCode=" + workOrderCode).header("Authorization", "Bearer " + token)
                .setFollowRedirects(true).timeout(30000).execute();
        HashMap workTraceInfo = JSONObject.parseObject(workTrace.body(), HashMap.class);
        Object data1 = workTraceInfo.get("Data");
        if (data1 == null) {
            //这里代表主表的信息不存在，没必要继续进行
            return null;
        }
        return JSONObject.toJSONString(data1);
    }

    @PostMapping("/getProjectCameraList")
    public String getProjectCameraList(@RequestBody Map<String, String> map) {
        String projectId = map.get("projectId");
        HttpResponse cameras = HttpUtil.createGet(dredgingCameraListUrl + "?ProjectId=" + projectId).setFollowRedirects(true).timeout(30000).execute();
        HashMap resultMap = JSONObject.parseObject(cameras.body(), HashMap.class);
        Object data = resultMap.get("Data");
        if (data == null){
            return null;
        }
        return JSONObject.toJSONString(data);
    }
}
